/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3 Standard
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 05.06.2016
Author  : IOPA4
Company : Home
Comments: http://iopa4.narod.ru


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 1,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// I2C Bus functions
#include <i2c.h>

// DS1307 Real Time Clock functions
#include <ds1307.h>

#define DS  PORTD.5
#define SH_CP PORTD.6
#define ST_CP PORTD.7
#define BIT(bit)  (1<<(bit))
#define OK     5
#define MINUS  6
#define PLUS   3

unsigned char hrs, mins, sec, tmp, start=1, btn=0;

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
  btn = PINC&0b00000111;
}

void min_out()
{
  static unsigned long min_data1=0, min_data2=0, min_data3=0, min_data4=0; 
  unsigned char j;
  tmp = mins%16;
  if (mins<16)
  {
    min_data1=0x8000; 
    min_data1=min_data1>>tmp;
  } else min_data1=0;

  if ((mins>=16)&&(mins<32))  
  {
    min_data2=0x8000; 
    min_data2=min_data2>>tmp;
  } else min_data2=0;
  
  if ((mins>=32)&&(mins<48))  
  {
    min_data3=0x8000; 
    min_data3=min_data3>>tmp;
  } else min_data3=0;

  if ((mins>=48)&&(mins<64))  
  {
    min_data4=0x8000; 
    min_data4=min_data4>>tmp;
  } else min_data4=0;
  ST_CP=0;      //   
  for (j=0; j<16; j++) 
  {
    if (min_data4 & BIT(j)) DS=1; else DS=0; // 32   74HC595
    delay_us(5);    
    SH_CP=0;
    delay_us(50);
    SH_CP=1;
  }
  for (j=0; j<16; j++) 
  {
    if (min_data3 & BIT(j)) DS=1; else DS=0; // 32   74HC595
    delay_us(5);    
    SH_CP=0;
    delay_us(50);
    SH_CP=1;
  } 
  for (j=0; j<16; j++) 
  {
    if (min_data2 & BIT(j)) DS=1; else DS=0; // 32   74HC595
    delay_us(5);    
    SH_CP=0;
    delay_us(50);
    SH_CP=1;
  } 
  for (j=0; j<16; j++) 
  {
    if (min_data1 & BIT(j)) DS=1; else DS=0; // 32   74HC595
    delay_us(5);    
    SH_CP=0;
    delay_us(50);
    SH_CP=1;
  }
  ST_CP=1;	//    
  delay_us(50); 
} 

void hrs_out(void)
{
  static unsigned char hr12;
  if (hrs>12) hr12=hrs - 12; else hr12 = hrs; 
  switch (hr12) 
  {
      case 1: PORTB = 1;  break;
      case 2: PORTB = 2;  break;
      case 3: PORTB = 4;  break;
      case 4: PORTB = 8;  break;
      case 5: PORTB = 16; break;
      case 6: PORTB = 32; break;
      case 7: PORTB = 64; break;
      case 8: PORTB = 128;break; 
      case 9: PORTD = PORTD|0b111000001;break;
      case 10: PORTD = PORTD|0b11100010;break;
      case 11: PORTD = PORTD|0b11100100;break;
      case 12: PORTD = PORTD|0b11101000;break;        
      default: PORTB = 0; PORTD = PORTD|0b11100000; 
      break;
  }; 
}

void menu(void)
{
  btn=0;
  while (btn!=OK)
  {
    if (btn==MINUS) {if (hrs>0)  hrs--; delay_ms(100); btn=0;};
    if (btn==PLUS)  {if (hrs<24) hrs++; delay_ms(100); btn=0;};
    hrs_out(); 
  }
  while (btn!=OK)
  {
    if (btn==MINUS) if (mins>0)  {mins--; delay_ms(100); btn=0;};
    if (btn==PLUS)  if (mins<59) {mins++; delay_ms(100); btn=0;};
    min_out();
  }
  #asm("cli")
  rtc_set_time(hrs, mins, 0);
  #asm("sei")
}
// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=T State3=0 State2=0 State1=0 State0=0 
PORTD=0x00;
DDRD=0xEF;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 0,977 kHz
TCCR0=0x05;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer1 Stopped
// Mode: Normal top=0xFFFF
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer2 Stopped
// Mode: Normal top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// USART initialization
// USART disabled
UCSRB=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// SPI initialization
// SPI disabled
SPCR=0x00;

// TWI initialization
// TWI disabled
TWCR=0x00;

// I2C Bus initialization
// I2C Port: PORTC
// I2C SDA bit: 4
// I2C SCL bit: 5
// Bit Rate: 100 kHz
// Note: I2C settings are specified in the
// Project|Configure|C Compiler|Libraries|I2C menu.
i2c_init();

// DS1307 Real Time Clock initialization
// Square wave output on pin SQW/OUT: Off
// SQW/OUT pin state: 1
rtc_init(0,0,1);

// Global enable interrupts
//#asm("sei")

while (1)
    {
      // Place your code here 
      if (btn==OK) menu();
      #asm("cli")
      rtc_get_time(&hrs, &mins, &sec); 
      #asm("sei")
      if ((sec==0)||(start))
      {
        start = 0;
        min_out();
        hrs_out();
      }
    }
}
