
;CodeVisionAVR C Compiler V2.05.3 Standard
;(C) Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 1,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;Global 'const' stored in FLASH     : No
;Enhanced function parameter passing: Yes
;Enhanced core instructions         : On
;Smart register allocation          : Off
;Automatic register allocation      : Off

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer0_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_0x3:
	.DB  0x1

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _start
	.DW  _0x3*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.3 Standard
;Automatic Program Generator
; Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 05.06.2016
;Author  : IOPA4
;Company : Home
;Comments: http://iopa4.narod.ru
;
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 1,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;
;// I2C Bus functions
;#include <i2c.h>
;
;// DS1307 Real Time Clock functions
;#include <ds1307.h>
;
;#define DS  PORTD.5
;#define SH_CP PORTD.6
;#define ST_CP PORTD.7
;#define BIT(bit)  (1<<(bit))
;#define OK     5
;#define MINUS  6
;#define PLUS   3
;
;unsigned char hrs, mins, sec, tmp, start=1, btn=0;

	.DSEG
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 002D {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 002E // Place your code here
; 0000 002F   btn = PINC&0b00000111;
	IN   R30,0x13
	ANDI R30,LOW(0x7)
	STS  _btn,R30
; 0000 0030 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;void min_out()
; 0000 0033 {
_min_out:
; 0000 0034   static unsigned long min_data1=0, min_data2=0, min_data3=0, min_data4=0;
; 0000 0035   unsigned char j;
; 0000 0036   tmp = mins%16;
	ST   -Y,R16
;	j -> R16
	LDS  R30,_mins
	ANDI R30,LOW(0xF)
	STS  _tmp,R30
; 0000 0037   if (mins<16)
	LDS  R26,_mins
	CPI  R26,LOW(0x10)
	BRSH _0x4
; 0000 0038   {
; 0000 0039     min_data1=0x8000;
	__GETD1N 0x8000
	STS  _min_data1_S0000001000,R30
	STS  _min_data1_S0000001000+1,R31
	STS  _min_data1_S0000001000+2,R22
	STS  _min_data1_S0000001000+3,R23
; 0000 003A     min_data1=min_data1>>tmp;
	LDS  R30,_tmp
	LDS  R26,_min_data1_S0000001000
	LDS  R27,_min_data1_S0000001000+1
	LDS  R24,_min_data1_S0000001000+2
	LDS  R25,_min_data1_S0000001000+3
	RCALL __LSRD12
	STS  _min_data1_S0000001000,R30
	STS  _min_data1_S0000001000+1,R31
	STS  _min_data1_S0000001000+2,R22
	STS  _min_data1_S0000001000+3,R23
; 0000 003B   } else min_data1=0;
	RJMP _0x5
_0x4:
	LDI  R30,LOW(0)
	STS  _min_data1_S0000001000,R30
	STS  _min_data1_S0000001000+1,R30
	STS  _min_data1_S0000001000+2,R30
	STS  _min_data1_S0000001000+3,R30
; 0000 003C 
; 0000 003D   if ((mins>=16)&&(mins<32))
_0x5:
	LDS  R26,_mins
	CPI  R26,LOW(0x10)
	BRLO _0x7
	CPI  R26,LOW(0x20)
	BRLO _0x8
_0x7:
	RJMP _0x6
_0x8:
; 0000 003E   {
; 0000 003F     min_data2=0x8000;
	__GETD1N 0x8000
	STS  _min_data2_S0000001000,R30
	STS  _min_data2_S0000001000+1,R31
	STS  _min_data2_S0000001000+2,R22
	STS  _min_data2_S0000001000+3,R23
; 0000 0040     min_data2=min_data2>>tmp;
	LDS  R30,_tmp
	LDS  R26,_min_data2_S0000001000
	LDS  R27,_min_data2_S0000001000+1
	LDS  R24,_min_data2_S0000001000+2
	LDS  R25,_min_data2_S0000001000+3
	RCALL __LSRD12
	STS  _min_data2_S0000001000,R30
	STS  _min_data2_S0000001000+1,R31
	STS  _min_data2_S0000001000+2,R22
	STS  _min_data2_S0000001000+3,R23
; 0000 0041   } else min_data2=0;
	RJMP _0x9
_0x6:
	LDI  R30,LOW(0)
	STS  _min_data2_S0000001000,R30
	STS  _min_data2_S0000001000+1,R30
	STS  _min_data2_S0000001000+2,R30
	STS  _min_data2_S0000001000+3,R30
; 0000 0042 
; 0000 0043   if ((mins>=32)&&(mins<48))
_0x9:
	LDS  R26,_mins
	CPI  R26,LOW(0x20)
	BRLO _0xB
	CPI  R26,LOW(0x30)
	BRLO _0xC
_0xB:
	RJMP _0xA
_0xC:
; 0000 0044   {
; 0000 0045     min_data3=0x8000;
	__GETD1N 0x8000
	STS  _min_data3_S0000001000,R30
	STS  _min_data3_S0000001000+1,R31
	STS  _min_data3_S0000001000+2,R22
	STS  _min_data3_S0000001000+3,R23
; 0000 0046     min_data3=min_data3>>tmp;
	LDS  R30,_tmp
	LDS  R26,_min_data3_S0000001000
	LDS  R27,_min_data3_S0000001000+1
	LDS  R24,_min_data3_S0000001000+2
	LDS  R25,_min_data3_S0000001000+3
	RCALL __LSRD12
	STS  _min_data3_S0000001000,R30
	STS  _min_data3_S0000001000+1,R31
	STS  _min_data3_S0000001000+2,R22
	STS  _min_data3_S0000001000+3,R23
; 0000 0047   } else min_data3=0;
	RJMP _0xD
_0xA:
	LDI  R30,LOW(0)
	STS  _min_data3_S0000001000,R30
	STS  _min_data3_S0000001000+1,R30
	STS  _min_data3_S0000001000+2,R30
	STS  _min_data3_S0000001000+3,R30
; 0000 0048 
; 0000 0049   if ((mins>=48)&&(mins<64))
_0xD:
	LDS  R26,_mins
	CPI  R26,LOW(0x30)
	BRLO _0xF
	CPI  R26,LOW(0x40)
	BRLO _0x10
_0xF:
	RJMP _0xE
_0x10:
; 0000 004A   {
; 0000 004B     min_data4=0x8000;
	__GETD1N 0x8000
	STS  _min_data4_S0000001000,R30
	STS  _min_data4_S0000001000+1,R31
	STS  _min_data4_S0000001000+2,R22
	STS  _min_data4_S0000001000+3,R23
; 0000 004C     min_data4=min_data4>>tmp;
	LDS  R30,_tmp
	LDS  R26,_min_data4_S0000001000
	LDS  R27,_min_data4_S0000001000+1
	LDS  R24,_min_data4_S0000001000+2
	LDS  R25,_min_data4_S0000001000+3
	RCALL __LSRD12
	STS  _min_data4_S0000001000,R30
	STS  _min_data4_S0000001000+1,R31
	STS  _min_data4_S0000001000+2,R22
	STS  _min_data4_S0000001000+3,R23
; 0000 004D   } else min_data4=0;
	RJMP _0x11
_0xE:
	LDI  R30,LOW(0)
	STS  _min_data4_S0000001000,R30
	STS  _min_data4_S0000001000+1,R30
	STS  _min_data4_S0000001000+2,R30
	STS  _min_data4_S0000001000+3,R30
; 0000 004E   ST_CP=0;      //   
_0x11:
	CBI  0x12,7
; 0000 004F   for (j=0; j<16; j++)
	LDI  R16,LOW(0)
_0x15:
	CPI  R16,16
	BRSH _0x16
; 0000 0050   {
; 0000 0051     if (min_data4 & BIT(j)) DS=1; else DS=0; // 32   74HC595
	MOV  R30,R16
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	LDS  R26,_min_data4_S0000001000
	LDS  R27,_min_data4_S0000001000+1
	LDS  R24,_min_data4_S0000001000+2
	LDS  R25,_min_data4_S0000001000+3
	CLR  R22
	CLR  R23
	RCALL __ANDD12
	RCALL __CPD10
	BREQ _0x17
	SBI  0x12,5
	RJMP _0x1A
_0x17:
	CBI  0x12,5
; 0000 0052     delay_us(5);
_0x1A:
	__DELAY_USB 2
; 0000 0053     SH_CP=0;
	CBI  0x12,6
; 0000 0054     delay_us(50);
	__DELAY_USB 17
; 0000 0055     SH_CP=1;
	SBI  0x12,6
; 0000 0056   }
	SUBI R16,-1
	RJMP _0x15
_0x16:
; 0000 0057   for (j=0; j<16; j++)
	LDI  R16,LOW(0)
_0x22:
	CPI  R16,16
	BRSH _0x23
; 0000 0058   {
; 0000 0059     if (min_data3 & BIT(j)) DS=1; else DS=0; // 32   74HC595
	MOV  R30,R16
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	LDS  R26,_min_data3_S0000001000
	LDS  R27,_min_data3_S0000001000+1
	LDS  R24,_min_data3_S0000001000+2
	LDS  R25,_min_data3_S0000001000+3
	CLR  R22
	CLR  R23
	RCALL __ANDD12
	RCALL __CPD10
	BREQ _0x24
	SBI  0x12,5
	RJMP _0x27
_0x24:
	CBI  0x12,5
; 0000 005A     delay_us(5);
_0x27:
	__DELAY_USB 2
; 0000 005B     SH_CP=0;
	CBI  0x12,6
; 0000 005C     delay_us(50);
	__DELAY_USB 17
; 0000 005D     SH_CP=1;
	SBI  0x12,6
; 0000 005E   }
	SUBI R16,-1
	RJMP _0x22
_0x23:
; 0000 005F   for (j=0; j<16; j++)
	LDI  R16,LOW(0)
_0x2F:
	CPI  R16,16
	BRSH _0x30
; 0000 0060   {
; 0000 0061     if (min_data2 & BIT(j)) DS=1; else DS=0; // 32   74HC595
	MOV  R30,R16
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	LDS  R26,_min_data2_S0000001000
	LDS  R27,_min_data2_S0000001000+1
	LDS  R24,_min_data2_S0000001000+2
	LDS  R25,_min_data2_S0000001000+3
	CLR  R22
	CLR  R23
	RCALL __ANDD12
	RCALL __CPD10
	BREQ _0x31
	SBI  0x12,5
	RJMP _0x34
_0x31:
	CBI  0x12,5
; 0000 0062     delay_us(5);
_0x34:
	__DELAY_USB 2
; 0000 0063     SH_CP=0;
	CBI  0x12,6
; 0000 0064     delay_us(50);
	__DELAY_USB 17
; 0000 0065     SH_CP=1;
	SBI  0x12,6
; 0000 0066   }
	SUBI R16,-1
	RJMP _0x2F
_0x30:
; 0000 0067   for (j=0; j<16; j++)
	LDI  R16,LOW(0)
_0x3C:
	CPI  R16,16
	BRSH _0x3D
; 0000 0068   {
; 0000 0069     if (min_data1 & BIT(j)) DS=1; else DS=0; // 32   74HC595
	MOV  R30,R16
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	LDS  R26,_min_data1_S0000001000
	LDS  R27,_min_data1_S0000001000+1
	LDS  R24,_min_data1_S0000001000+2
	LDS  R25,_min_data1_S0000001000+3
	CLR  R22
	CLR  R23
	RCALL __ANDD12
	RCALL __CPD10
	BREQ _0x3E
	SBI  0x12,5
	RJMP _0x41
_0x3E:
	CBI  0x12,5
; 0000 006A     delay_us(5);
_0x41:
	__DELAY_USB 2
; 0000 006B     SH_CP=0;
	CBI  0x12,6
; 0000 006C     delay_us(50);
	__DELAY_USB 17
; 0000 006D     SH_CP=1;
	SBI  0x12,6
; 0000 006E   }
	SUBI R16,-1
	RJMP _0x3C
_0x3D:
; 0000 006F   ST_CP=1;	//    
	SBI  0x12,7
; 0000 0070   delay_us(50);
	__DELAY_USB 17
; 0000 0071 }
	LD   R16,Y+
	RET
;
;void hrs_out(void)
; 0000 0074 {
_hrs_out:
; 0000 0075   static unsigned char hr12;
; 0000 0076   if (hrs>12) hr12=hrs - 12; else hr12 = hrs;
	LDS  R26,_hrs
	CPI  R26,LOW(0xD)
	BRLO _0x4A
	LDS  R30,_hrs
	SUBI R30,LOW(12)
	RJMP _0x72
_0x4A:
	LDS  R30,_hrs
_0x72:
	STS  _hr12_S0000002000,R30
; 0000 0077   switch (hr12)
	LDI  R31,0
; 0000 0078   {
; 0000 0079       case 1: PORTB = 1;  break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x4F
	LDI  R30,LOW(1)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 007A       case 2: PORTB = 2;  break;
_0x4F:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x50
	LDI  R30,LOW(2)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 007B       case 3: PORTB = 4;  break;
_0x50:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x51
	LDI  R30,LOW(4)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 007C       case 4: PORTB = 8;  break;
_0x51:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x52
	LDI  R30,LOW(8)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 007D       case 5: PORTB = 16; break;
_0x52:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x53
	LDI  R30,LOW(16)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 007E       case 6: PORTB = 32; break;
_0x53:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x54
	LDI  R30,LOW(32)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 007F       case 7: PORTB = 64; break;
_0x54:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x55
	LDI  R30,LOW(64)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 0080       case 8: PORTB = 128;break;
_0x55:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x56
	LDI  R30,LOW(128)
	OUT  0x18,R30
	RJMP _0x4E
; 0000 0081       case 9: PORTD = PORTD|0b111000001;break;
_0x56:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x57
	IN   R30,0x12
	ORI  R30,LOW(0xC1)
	RJMP _0x73
; 0000 0082       case 10: PORTD = PORTD|0b11100010;break;
_0x57:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x58
	IN   R30,0x12
	ORI  R30,LOW(0xE2)
	RJMP _0x73
; 0000 0083       case 11: PORTD = PORTD|0b11100100;break;
_0x58:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BRNE _0x59
	IN   R30,0x12
	ORI  R30,LOW(0xE4)
	RJMP _0x73
; 0000 0084       case 12: PORTD = PORTD|0b11101000;break;
_0x59:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BRNE _0x5B
	IN   R30,0x12
	ORI  R30,LOW(0xE8)
	RJMP _0x73
; 0000 0085       default: PORTB = 0; PORTD = PORTD|0b11100000;
_0x5B:
	LDI  R30,LOW(0)
	OUT  0x18,R30
	IN   R30,0x12
	ORI  R30,LOW(0xE0)
_0x73:
	OUT  0x12,R30
; 0000 0086       break;
; 0000 0087   };
_0x4E:
; 0000 0088 }
	RET
;
;void menu(void)
; 0000 008B {
_menu:
; 0000 008C   btn=0;
	LDI  R30,LOW(0)
	STS  _btn,R30
; 0000 008D   while (btn!=OK)
_0x5C:
	LDS  R26,_btn
	CPI  R26,LOW(0x5)
	BREQ _0x5E
; 0000 008E   {
; 0000 008F     if (btn==MINUS) {if (hrs>0)  hrs--; delay_ms(100); btn=0;};
	CPI  R26,LOW(0x6)
	BRNE _0x5F
	LDS  R26,_hrs
	CPI  R26,LOW(0x1)
	BRLO _0x60
	LDS  R30,_hrs
	SUBI R30,LOW(1)
	STS  _hrs,R30
_0x60:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _btn,R30
_0x5F:
; 0000 0090     if (btn==PLUS)  {if (hrs<24) hrs++; delay_ms(100); btn=0;};
	LDS  R26,_btn
	CPI  R26,LOW(0x3)
	BRNE _0x61
	LDS  R26,_hrs
	CPI  R26,LOW(0x18)
	BRSH _0x62
	LDS  R30,_hrs
	SUBI R30,-LOW(1)
	STS  _hrs,R30
_0x62:
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _btn,R30
_0x61:
; 0000 0091     hrs_out();
	RCALL _hrs_out
; 0000 0092   }
	RJMP _0x5C
_0x5E:
; 0000 0093   while (btn!=OK)
_0x63:
	LDS  R26,_btn
	CPI  R26,LOW(0x5)
	BREQ _0x65
; 0000 0094   {
; 0000 0095     if (btn==MINUS) if (mins>0)  {mins--; delay_ms(100); btn=0;};
	CPI  R26,LOW(0x6)
	BRNE _0x66
	LDS  R26,_mins
	CPI  R26,LOW(0x1)
	BRLO _0x67
	LDS  R30,_mins
	SUBI R30,LOW(1)
	STS  _mins,R30
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _btn,R30
_0x67:
_0x66:
; 0000 0096     if (btn==PLUS)  if (mins<59) {mins++; delay_ms(100); btn=0;};
	LDS  R26,_btn
	CPI  R26,LOW(0x3)
	BRNE _0x68
	LDS  R26,_mins
	CPI  R26,LOW(0x3B)
	BRSH _0x69
	LDS  R30,_mins
	SUBI R30,-LOW(1)
	STS  _mins,R30
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
	LDI  R30,LOW(0)
	STS  _btn,R30
_0x69:
_0x68:
; 0000 0097     min_out();
	RCALL _min_out
; 0000 0098   }
	RJMP _0x63
_0x65:
; 0000 0099   #asm("cli")
	cli
; 0000 009A   rtc_set_time(hrs, mins, 0);
	LDS  R30,_hrs
	ST   -Y,R30
	LDS  R30,_mins
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _rtc_set_time
; 0000 009B   #asm("sei")
	sei
; 0000 009C }
	RET
;// Declare your global variables here
;
;void main(void)
; 0000 00A0 {
_main:
; 0000 00A1 // Declare your local variables here
; 0000 00A2 
; 0000 00A3 // Input/Output Ports initialization
; 0000 00A4 // Port B initialization
; 0000 00A5 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00A6 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
; 0000 00A7 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
; 0000 00A8 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
; 0000 00A9 
; 0000 00AA // Port C initialization
; 0000 00AB // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 00AC // State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 00AD PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
; 0000 00AE DDRC=0x00;
	OUT  0x14,R30
; 0000 00AF 
; 0000 00B0 // Port D initialization
; 0000 00B1 // Func7=Out Func6=Out Func5=Out Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 00B2 // State7=0 State6=0 State5=0 State4=T State3=0 State2=0 State1=0 State0=0
; 0000 00B3 PORTD=0x00;
	OUT  0x12,R30
; 0000 00B4 DDRD=0xEF;
	LDI  R30,LOW(239)
	OUT  0x11,R30
; 0000 00B5 
; 0000 00B6 // Timer/Counter 0 initialization
; 0000 00B7 // Clock source: System Clock
; 0000 00B8 // Clock value: 0,977 kHz
; 0000 00B9 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
; 0000 00BA TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 00BB 
; 0000 00BC // Timer/Counter 1 initialization
; 0000 00BD // Clock source: System Clock
; 0000 00BE // Clock value: Timer1 Stopped
; 0000 00BF // Mode: Normal top=0xFFFF
; 0000 00C0 // OC1A output: Discon.
; 0000 00C1 // OC1B output: Discon.
; 0000 00C2 // Noise Canceler: Off
; 0000 00C3 // Input Capture on Falling Edge
; 0000 00C4 // Timer1 Overflow Interrupt: Off
; 0000 00C5 // Input Capture Interrupt: Off
; 0000 00C6 // Compare A Match Interrupt: Off
; 0000 00C7 // Compare B Match Interrupt: Off
; 0000 00C8 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 00C9 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 00CA TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 00CB TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 00CC ICR1H=0x00;
	OUT  0x27,R30
; 0000 00CD ICR1L=0x00;
	OUT  0x26,R30
; 0000 00CE OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 00CF OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 00D0 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 00D1 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 00D2 
; 0000 00D3 // Timer/Counter 2 initialization
; 0000 00D4 // Clock source: System Clock
; 0000 00D5 // Clock value: Timer2 Stopped
; 0000 00D6 // Mode: Normal top=0xFF
; 0000 00D7 // OC2 output: Disconnected
; 0000 00D8 ASSR=0x00;
	OUT  0x22,R30
; 0000 00D9 TCCR2=0x00;
	OUT  0x25,R30
; 0000 00DA TCNT2=0x00;
	OUT  0x24,R30
; 0000 00DB OCR2=0x00;
	OUT  0x23,R30
; 0000 00DC 
; 0000 00DD // External Interrupt(s) initialization
; 0000 00DE // INT0: Off
; 0000 00DF // INT1: Off
; 0000 00E0 MCUCR=0x00;
	OUT  0x35,R30
; 0000 00E1 
; 0000 00E2 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 00E3 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
; 0000 00E4 
; 0000 00E5 // USART initialization
; 0000 00E6 // USART disabled
; 0000 00E7 UCSRB=0x00;
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 00E8 
; 0000 00E9 // Analog Comparator initialization
; 0000 00EA // Analog Comparator: Off
; 0000 00EB // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 00EC ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 00ED SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 00EE 
; 0000 00EF // ADC initialization
; 0000 00F0 // ADC disabled
; 0000 00F1 ADCSRA=0x00;
	OUT  0x6,R30
; 0000 00F2 
; 0000 00F3 // SPI initialization
; 0000 00F4 // SPI disabled
; 0000 00F5 SPCR=0x00;
	OUT  0xD,R30
; 0000 00F6 
; 0000 00F7 // TWI initialization
; 0000 00F8 // TWI disabled
; 0000 00F9 TWCR=0x00;
	OUT  0x36,R30
; 0000 00FA 
; 0000 00FB // I2C Bus initialization
; 0000 00FC // I2C Port: PORTC
; 0000 00FD // I2C SDA bit: 4
; 0000 00FE // I2C SCL bit: 5
; 0000 00FF // Bit Rate: 100 kHz
; 0000 0100 // Note: I2C settings are specified in the
; 0000 0101 // Project|Configure|C Compiler|Libraries|I2C menu.
; 0000 0102 i2c_init();
	RCALL _i2c_init
; 0000 0103 
; 0000 0104 // DS1307 Real Time Clock initialization
; 0000 0105 // Square wave output on pin SQW/OUT: Off
; 0000 0106 // SQW/OUT pin state: 1
; 0000 0107 rtc_init(0,0,1);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R26,LOW(1)
	RCALL _rtc_init
; 0000 0108 
; 0000 0109 // Global enable interrupts
; 0000 010A //#asm("sei")
; 0000 010B 
; 0000 010C while (1)
_0x6A:
; 0000 010D     {
; 0000 010E       // Place your code here
; 0000 010F       if (btn==OK) menu();
	LDS  R26,_btn
	CPI  R26,LOW(0x5)
	BRNE _0x6D
	RCALL _menu
; 0000 0110       #asm("cli")
_0x6D:
	cli
; 0000 0111       rtc_get_time(&hrs, &mins, &sec);
	LDI  R30,LOW(_hrs)
	LDI  R31,HIGH(_hrs)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_mins)
	LDI  R31,HIGH(_mins)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R26,LOW(_sec)
	LDI  R27,HIGH(_sec)
	RCALL _rtc_get_time
; 0000 0112       #asm("sei")
	sei
; 0000 0113       if ((sec==0)||(start))
	LDS  R26,_sec
	CPI  R26,LOW(0x0)
	BREQ _0x6F
	LDS  R30,_start
	CPI  R30,0
	BREQ _0x6E
_0x6F:
; 0000 0114       {
; 0000 0115         start = 0;
	LDI  R30,LOW(0)
	STS  _start,R30
; 0000 0116         min_out();
	RCALL _min_out
; 0000 0117         hrs_out();
	RCALL _hrs_out
; 0000 0118       }
; 0000 0119     }
_0x6E:
	RJMP _0x6A
; 0000 011A }
_0x71:
	RJMP _0x71

	.CSEG
_rtc_init:
	ST   -Y,R26
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2000003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2000003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2000004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2000004:
	RCALL _i2c_start
	LDI  R26,LOW(208)
	RCALL _i2c_write
	LDI  R26,LOW(7)
	RCALL _i2c_write
	LDD  R26,Y+2
	RJMP _0x2040001
_rtc_get_time:
	ST   -Y,R27
	ST   -Y,R26
	RCALL _i2c_start
	LDI  R26,LOW(208)
	RCALL _i2c_write
	LDI  R26,LOW(0)
	RCALL _i2c_write
	RCALL _i2c_stop
	RCALL _i2c_start
	LDI  R26,LOW(209)
	RCALL _i2c_write
	LDI  R26,LOW(1)
	RCALL _i2c_read
	MOV  R26,R30
	RCALL _bcd2bin
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
	LDI  R26,LOW(1)
	RCALL _i2c_read
	MOV  R26,R30
	RCALL _bcd2bin
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R26,LOW(0)
	RCALL _i2c_read
	MOV  R26,R30
	RCALL _bcd2bin
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	RCALL _i2c_stop
	ADIW R28,6
	RET
_rtc_set_time:
	ST   -Y,R26
	RCALL _i2c_start
	LDI  R26,LOW(208)
	RCALL _i2c_write
	LDI  R26,LOW(0)
	RCALL _i2c_write
	LD   R26,Y
	RCALL _bin2bcd
	MOV  R26,R30
	RCALL _i2c_write
	LDD  R26,Y+1
	RCALL _bin2bcd
	MOV  R26,R30
	RCALL _i2c_write
	LDD  R26,Y+2
	RCALL _bin2bcd
	MOV  R26,R30
_0x2040001:
	RCALL _i2c_write
	RCALL _i2c_stop
	ADIW R28,3
	RET

	.CSEG
_bcd2bin:
	ST   -Y,R26
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
	ST   -Y,R26
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
_hrs:
	.BYTE 0x1
_mins:
	.BYTE 0x1
_sec:
	.BYTE 0x1
_tmp:
	.BYTE 0x1
_start:
	.BYTE 0x1
_btn:
	.BYTE 0x1
_min_data1_S0000001000:
	.BYTE 0x4
_min_data2_S0000001000:
	.BYTE 0x4
_min_data3_S0000001000:
	.BYTE 0x4
_min_data4_S0000001000:
	.BYTE 0x4
_hr12_S0000002000:
	.BYTE 0x1

	.CSEG

	.CSEG
	.equ __sda_bit=4
	.equ __scl_bit=5
	.equ __i2c_port=0x15 ;PORTC
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2

_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,2
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,3
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	mov  r23,r26
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ldi  r23,8
__i2c_write0:
	lsl  r26
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANDD12:
	AND  R30,R26
	AND  R31,R27
	AND  R22,R24
	AND  R23,R25
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSRD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSRD12R
__LSRD12L:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRD12L
__LSRD12R:
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

;END OF CODE MARKER
__END_OF_CODE:
